/*
 * Copyright (c) 2011, Noel Lemouel
 * All rights reserved.
 */

#include "pic32-io.h"

#define IO_UART1_BASE 0xbf806000;

void uart1_init()
{
   volatile unsigned int i;

   uart_sfr_t* uart1;
   uart1 = (uart_sfr_t*)IO_UART1_BASE;

   uart1->ubrg = 51;
   uart1->usta = 0;
   uart1->umode = 0x8000;
   uart1->usta = 0x1400;

   /* keep uart1 TX high long enough for host to see a valid TX sequence */
   i = 10000; while(i--); /* 80ms delay at 8Mhz */
}

void uart_putc(unsigned char c)
{
   uart_sfr_t* uart1;

   uart1 = (uart_sfr_t*)IO_UART1_BASE;

   while (!((uart1->usta) & 0x100));

   uart1->utxreg = c;
}

unsigned char uart_getc(void)
{
   uart_sfr_t* uart1;

   uart1 = (uart_sfr_t*)IO_UART1_BASE;

   while (!((uart1->usta) & 0x001));

   return (uart1->urxreg);
}
